petsc-3.6.2 2015-10-02
Report Typos and Errors

# DMDACreate2d

Creates an object that will manage the communication of two-dimensional regular array data that is distributed across some processors.

### Synopsis

    #include "petscdmda.h"
    PetscErrorCode  DMDACreate2d(MPI_Comm comm,DMBoundaryType bx,DMBoundaryType by,DMDAStencilType stencil_type,
                              PetscInt M,PetscInt N,PetscInt m,PetscInt n,PetscInt dof,PetscInt s,const PetscInt lx[],const PetscInt ly[],DM *da)

Collective on MPI_Comm

### Input Parameters

| comm | - MPI communicator
| bx,by | - type of ghost nodes the array have. Use one of DM_BOUNDARY_NONE, DM_BOUNDARY_GHOSTED, DM_BOUNDARY_PERIODIC.
| stencil_type | - stencil type. Use either DMDA_STENCIL_BOX or DMDA_STENCIL_STAR.
| M,N | - global dimension in each direction of the array (use -M and or -N to indicate that it may be set to a different value from the command line with -da_grid_x <M> -da_grid_y <N>)
| m,n | - corresponding number of processors in each dimension (or PETSC_DECIDE to have calculated)
| dof | - number of degrees of freedom per node
| s | - stencil width
| lx, ly | - arrays containing the number of nodes in each cell along the x and y coordinates, or NULL. If non-null, these must be of length as m and n, and the corresponding m and n cannot be PETSC_DECIDE. The sum of the lx[] entries must be M, and the sum of the ly[] entries must be N.

### Output Parameter

da -the resulting distributed array object

### Options Database Key

| -dm_view | - Calls DMView() at the conclusion of DMDACreate2d()
| -da_grid_x <nx> | - number of grid points in x direction, if M < 0
| -da_grid_y <ny> | - number of grid points in y direction, if N < 0
| -da_processors_x <nx> | - number of processors in x direction
| -da_processors_y <ny> | - number of processors in y direction
| -da_refine_x <rx> | - refinement ratio in x direction
| -da_refine_y <ry> | - refinement ratio in y direction
| -da_refine <n> | - refine the DMDA n times before creating, if M or N < 0

### Notes

The stencil type DMDA_STENCIL_STAR with width 1 corresponds to the standard 5-pt stencil, while DMDA_STENCIL_BOX with width 1 denotes the standard 9-pt stencil.

The array data itself is NOT stored in the DMDA, it is stored in Vec objects; The appropriate vector objects can be obtained with calls to DMCreateGlobalVector() and DMCreateLocalVector() and calls to VecDuplicate() if more are needed.

### Keywords

distributed array, create, two-dimensional

### See Also

DMDestroy(), DMView(), DMDACreate1d(), DMDACreate3d(), DMGlobalToLocalBegin(), DMDAGetRefinementFactor(),
DMGlobalToLocalEnd(), DMLocalToGlobalBegin(), DMLocalToLocalBegin(), DMLocalToLocalEnd(), DMDASetRefinementFactor(), DMDAGetInfo(), DMCreateGlobalVector(), DMCreateLocalVector(), DMDACreateNaturalVector(), DMLoad(), DMDAGetOwnershipRanges()

Level:beginner
Location:src/dm/impls/da/da2.c
Index of all DM routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/dm/examples/tutorials/ex1.c.html
src/dm/examples/tutorials/ex2.c.html
src/dm/examples/tutorials/ex3.c.html
src/dm/examples/tutorials/ex4.c.html
src/dm/examples/tutorials/ex5.c.html
src/dm/examples/tutorials/ex6.c.html
src/dm/examples/tutorials/ex7.c.html
src/dm/examples/tutorials/ex9.c.html
src/dm/examples/tutorials/ex10.c.html
src/dm/examples/tutorials/ex12.c.html
src/dm/examples/tutorials/ex51.c.html